#!/usr/bin/env python2.3
import sys
import string

def floattest(valuestring):
    for x in valuestring:
        if x not in string.digits + '.':
            return 0
    else:
        return 1

if len(sys.argv) != 5:
    print """Usage: MueSigmaEvaluation.py <BeforeTrainingFile> <AfterTrainingFile1> <AfterTrainingFile2>
    <Outputfile>"""
    sys.exit()
    
debug = 0
    
beforefile = open(sys.argv[1], "r")
afterfile1 = open(sys.argv[2], "r")
afterfile2 = open(sys.argv[3], "r")
outfile = open(sys.argv[4] + ".eval", "w")
ErrorVector = open(sys.argv[4] + ".errvec", "w")
MixEstimator = open("Mix" + sys.argv[4] + ".arr", "w")
ClusEstimator = open("Clus" + sys.argv[4] + ".arr", "w")

beforelist = beforefile.readlines()
afterlist1 = afterfile1.readlines()
afterlist2 = afterfile2.readlines()

if debug:
    outputlist = [[[2.4554, 7.0980, 9.0980, 8.8173],[2.4554, 7.0980, 9.0980, 8.8173],[2.4554, 7.0980, 9.0980, 8.8173]],[[2.4554, 7.0980, 9.0980, 8.8173],[2.4554, 7.0980, 9.0980, 8.8173],[2.4554, 7.0980, 9.0980, 8.8173]]]

outputlist = []

modelcounter = -1
n = 0




while n < (len(beforelist)):
    line = string.strip(beforelist[n])
    if line == "":
	n += 1
	continue
    if line[0:4] == 'SHMM':
	modelcounter += 1
	outputlist.append([])
    if line[0] == 'N':
	stateline = string.split(line)
	statecounter = int(stateline[len(stateline)-1][0:-1])
	for state in range(statecounter):
	    outputlist[modelcounter].append([])
    if line[0:3] == 'Mue':
	for state in range(statecounter):
	    n += 1
	    line = string.strip(beforelist[n])
            muehelplist = string.split(line[0:-1], ',')
	    mue = string.atof(muehelplist[0])
	    outputlist[modelcounter][state].append(mue)
    if line[0] == 'U':
	for state in range(statecounter):
	    n += 1
	    line = string.strip(beforelist[n])
            sigmahelplist = string.split(line[0:-1], ',')
	    sigma = string.atof(sigmahelplist[0])
	    outputlist[modelcounter][state].append(sigma)	
    n += 1
	
if debug:
    print outputlist
    
modelcounter = -1
n = 0
while n < (len(afterlist1)):
    line = string.strip(afterlist1[n])
    if line == "":
	n += 1
	continue
    if line[0:4] == 'SHMM':
	modelcounter += 1
    if line[0:3] == 'Mue':
	for state in range(len(outputlist[modelcounter])):
	    n += 1
	    line = string.strip(afterlist1[n])
            muehelplist = string.split(line[0:-1], ',')
	    mue = string.atof(muehelplist[0])
	    outputlist[modelcounter][state].append(mue)
    if line[0] == 'U':
	for state in range(len(outputlist[modelcounter])):
	    if debug:
		print line
	    n += 1
	    line = string.strip(afterlist1[n])
	    if debug:
		print line
            sigmahelplist = string.split(line[0:-1], ',')
	    sigma = string.atof(sigmahelplist[0])
	    outputlist[modelcounter][state].append(sigma)	
    n += 1



modelcounter = -1
n = 0   
while n < (len(afterlist2)):
    line = string.strip(afterlist2[n])
    if line == "":
	n += 1
	continue
    if line[0:4] == 'SHMM':
	modelcounter += 1
    if line[0:3] == 'Mue':
	for state in range(len(outputlist[modelcounter])):
	    n += 1
	    line = string.strip(afterlist2[n])
            muehelplist = string.split(line[0:-1], ',')
	    mue = string.atof(muehelplist[0])
	    outputlist[modelcounter][state].append(mue)
    if line[0] == 'U':
	for state in range(len(outputlist[modelcounter])):
	    if debug:
		print line
	    n += 1
	    line = string.strip(afterlist2[n])
	    if debug:
		print line
            sigmahelplist = string.split(line[0:-1], ',')
	    sigma = string.atof(sigmahelplist[0])
	    outputlist[modelcounter][state].append(sigma)	
    n += 1

QuadraticError = [0.0,0.0]

outputstring = '\t\tbefore training\t\tafter training1\t\tafter training2\n\t\tMue\t  Sigma\t\tMue\t  Sigma\t\tMue\t  Sigma\n'
for i in range(len(outputlist)):
    outputstring += 'Model No. %d:\n' % i
    for j in range(len(outputlist[i])-1):
        QuadraticError[0] += (outputlist[i][j][0] - outputlist[i][j][2])**2
        QuadraticError[1] += (outputlist[i][j][0] - outputlist[i][j][4])**2
        vectorstring = "%2.4f\t%2.4f\n" % (abs(outputlist[i][j][0] - outputlist[i][j][2]),abs(outputlist[i][j][0] - outputlist[i][j][4]))
        ErrorVector.write(vectorstring)
        if i == len(outputlist)-1 and j == len(outputlist[i])-2: #j is state, last state is 9999.99 state -> not interesting
            mixestimatorstring = "%2.4f\n" % (outputlist[i][j][2])
            clusestimatorstring = "%2.4f\n" % (outputlist[i][j][4])
        else:
            mixestimatorstring = "%2.4f\t" % (outputlist[i][j][2])
            clusestimatorstring = "%2.4f\t" % (outputlist[i][j][4])
        MixEstimator.write(mixestimatorstring)
        ClusEstimator.write(clusestimatorstring)
	outputstring += 'State No. %d:\t%2.4f +- %2.4f\t%2.4f +- %2.4f\t%2.4f +- %2.4f\n' % (j+1, outputlist[i][j][0],
                                                                                             outputlist[i][j][1],
                                                                                             outputlist[i][j][2],
                                                                                             outputlist[i][j][3],
                                                                                             outputlist[i][j][4],
                                                                                             outputlist[i][j][5])
    outputstring += '\n\n'

outfile.write(outputstring)
outstring = "Total quadratic errors:\n\n%2.4f\t%2.4f\n" % (QuadraticError[0], QuadraticError[1])
outfile.write(outstring)

beforefile.close()
afterfile1.close()
afterfile2.close()
ErrorVector.close()
MixEstimator.close()
ClusEstimator.close()
outfile.close()
