from urllib2 import urlopen
from ClientForm import ParseResponse
from sgmllib import SGMLParser

class URLLister(SGMLParser):
    def reset(self):
        SGMLParser.reset(self)
        self.urls = []

    def start_a(self, attrs):
        href = [v for k, v in attrs if k=='href']
        if href:
            self.urls.extend(href)


def goStat(listOfGenes, fileName, listOfReferenceGenes =""):
    """Small script for getting results trough a post request from GOstat

    the parser is not very robust, so changes in the page format can bring
    problens"""

    forms = ParseResponse(urlopen("http://gostat.wehi.edu.au/cgi-bin/goStat.pl"))
    form = forms[0]
    #print form

    if listOfGenes == "":
        print "noGenes"
        return [0.0,0.0]

    # setting up the parameters
    form["text1"] = listOfGenes
    form["text2"] = listOfReferenceGenes
    form.set_value(["goa_human"], "prefix", by_label=True)
    form.set_value(["TEXT, GO Stats only"], "displaytype", by_label=True)
    form.set_value(["1"], "plcutoff", by_label=True)
    form.set_value(["30"], "ccutoff", by_label=True)
    # form.click() returns a urllib2.Request object
    # (see HTMLForm.click.__doc__ if you don't have urllib2)

    response = urlopen(form.click("submit"))
    parser = URLLister()
    parser.feed(response.read())
    response.close()
    parser.close()
    for url in parser.urls:
        response = urlopen("http://gostat.wehi.edu.au/cgi-bin/"+url)
        lines = response.readlines()
    response.close()


    outfile = open(fileName,'a')
    outfile.write("".join(lines[:24]))

    totalCountMean = 0
    totalCountMax = 0
    for l in lines[24:]: #starting at line 25
        outfile.write(l)
        l = l.split('\t')
        if int(l[3]) == 1: # if only one gene at the group ... don;t count it ...
	    print l
	    break
        if int(l[2]) == 1 & int(l[3]) == 2: # if only one gene at the group from 2... don;t count it ...
	    print l
	    break
        gos = l[5]
        gos = gos.split(';')
        count = 0.0
        maxi = 0.0
        for go in gos[:-1]:
            sum = go.count('%') + go.count('#')
            count += sum
            maxi = max(maxi,sum)

        level = count/float(len(gos[:-1]))
        totalCountMean+=level
        totalCountMax += maxi

    outfile.close()

    meanLevel = 0.0
    meanMaxLevel = 0.0

    if(len(lines[24:]) != 0):
        meanLevel = totalCountMean/float(len(lines[24:]))
        meanMaxLevel = totalCountMax/float(len(lines[24:]))
    else:
        print "no level", listOfGenes
    return [meanLevel, meanMaxLevel]


print goStat("REC107","result.txt")
