import GQLMixture
import GQLCluster
import GQLValidation
import Numeric
import ghmm
import math
import time




if __name__ == '__main__':

    import sys

#    process_id = pypar.rank()
#    no_processes = pypar.size()


    fileName = sys.argv[1]
    modelFileName = sys.argv[2]
    numberOfCuttoffs = int(sys.argv[3])


    profileSet = GQLCluster.ProfileSet()
    sequenceSet = ghmm.SequenceSet(ghmm.Float(),fileName)
    profileSet.ReadDataFromDSequences(sequenceSet,fileName)
#    sequenceSet = profileSet.ReadDataFromCaged(fileName)
    profile = GQLCluster.ProfileClustering()
    profile.setProfileSet(profileSet)
    profile.readModels(modelFileName)


    [likehoodT, alphat, expt] = GQLMixture.estimate_mixture(profile.modelList(),
							    sequenceSet, 0, 0.01, 												                                    profile.fixed_models)

    cluster = GQLMixture.decode_mixture(expt, len(profile.modelList()))

    profile.P = expt
    profile.clusters = []
    for i in xrange(len(profile.modelList())):
       profile.clusters.append([])
    for i, c in enumerate(cluster):
       profile.clusters[c].append(i)

    profile.calculateEntropies()

    clusterings = [profile.clusters]
#    cutOffStep = math.log(profile.maxEntropy)/numberOfCuttoffs
    cutOffStep = (profile.maxEntropy+0.001)/numberOfCuttoffs


    file =  open(modelFileName+".res","w")

    for i in range(numberOfCuttoffs):

        [show,hide] = profile.EntropyCutoff((profile.maxEntropy+0.001)-cutOffStep*i)

	newClasses = []
	newClusters = []

        for prof in show:
		newClasses.append(profile.profileSet.seq_classes[prof])
		newClusters.append(cluster[prof])

	print newClasses, newClusters

	(contigencyTable,rand,sen,spe,cr)= GQLValidation.computeExternalIndices(newClasses,newClusters,
	                                                                        profileSet.classes_no,profileSet.classes_no)
        file.write("%f\t%f\t%f\t%f\n"%((profile.maxEntropy-i*cutOffStep),rand,sen,spe))

    file.close()
