import GQLMixture
import GQLCluster
import GQLValidation
import GOStatParser
import Numeric
import ghmm
import math
import time




if __name__ == '__main__':

    import sys

#    process_id = pypar.rank()
#    no_processes = pypar.size()


    fileName = sys.argv[1]
    modelFileName = sys.argv[2]
    numberOfCuttoffs = int(sys.argv[3])


    profileSet = GQLCluster.ProfileSet()
#    sequenceSet = ghmm.SequenceSet(ghmm.Float(),fileName)
#    profileSet.ReadDataFromDSequences(sequenceSet,fileName)
    sequenceSet = profileSet.ReadDataFromCaged(fileName)
    profile = GQLCluster.ProfileClustering()
    profile.setProfileSet(profileSet)
    profile.readModels(modelFileName)


    [likehoodT, alphat, expt] = GQLMixture.estimate_mixture(profile.modelList(),
							    sequenceSet, 0, 0.01, 												                                    profile.fixed_models)

    cluster = GQLMixture.decode_mixture(expt, len(profile.modelList()))

    profile.P = expt
    profile.clusters = []
    for i in xrange(len(profile.modelList())):
       profile.clusters.append([])
    for i, c in enumerate(cluster):
       profile.clusters[c].append(i)

    profile.calculateEntropies()

    clusterings = [profile.clusters]
#    cutOffStep = math.log(profile.maxEntropy)/numberOfCuttoffs
    cutOffStep = profile.maxEntropy/numberOfCuttoffs
    print clusterings[0]
    for i in range(1,numberOfCuttoffs):
#        clusterings.append(profile.getClustersAfterCuttoff(profile.maxEntropy-math.exp(cutOffStep)*i))
        clusterings.append(profile.getClustersAfterCuttoff(profile.maxEntropy-cutOffStep*i))

#	print profile.maxEntropy-math.exp(i*cutOffStep)
	print profile.maxEntropy-(i*cutOffStep)
	print clusterings[i]

    file =  open(fileName+".res","w")

    for i,clustering in enumerate(clusterings):
        meanLevel = 0.0
	maxLevel = 0.0
        count = 0
#        file.write("%i\t%f"%(i,profile.maxEntropy-math.exp(cutOffStep)*i))
        file.write("%i\t%f"%(i,profile.maxEntropy-cutOffStep*i))

        allIds = []
#        for c in clustering:
#            allIds += c
#        allSet = profileSet.getSubset(allIds)
#	print "all set : "," ".join(allSet.genename)

        for c in clustering:
	    name = "go_results_%f_"%(i*cutOffStep)+fileName
            subSet = profileSet.getSubset(c)
	    [meanLevelAux,maxLevelAux] = GOStatParser.goStat(" ".join(subSet.genename),name)
#							     listOfReferenceGenes = " ".join(allSet.genename))
            file.write("\t%f\t%f"%(meanLevelAux,maxLevelAux))
	    if meanLevelAux != 0.0:
	        meanLevel += meanLevelAux
	        maxLevel += maxLevelAux
		print meanLevel,maxLevel
		count += 1
	    time.sleep(1.0)
	if count == 0.0:
	  count = 0.0000000001
	file.write("\t%f\t%f\n"%(meanLevel/float(count),maxLevel/float(count)))
	print meanLevel/float(count),maxLevel/float(count)
    file.close()
